/*****************************************************************************/
/* main.h : Donnes globales et fentre principale
 * main.h : Global data and main window
 *
 *
 * Greffon ToutDoux : Communication avec une base de donnes
 * ToutDoux's plug-in : Data base communication
 * Copyright (c) 2000 Philippe Roy
 * Auteur - Author : Philippe Roy <ph_roy@yahoo.com>
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/

#include <toutdoux.h>


/*****************************************************************************/
/* Variables globales */
/*****************************************************************************/
GtkObject *mod; /* Module */

/*****************************************************************************/
/* Module */
/*****************************************************************************/
GtkObject *plugins_about_def (void);
void mod_about (void);
GtkObject *mod_def (void);
void plugins_show (gboolean exist);
void plugins_hide (void);
void plugins_destroy (void);

/*****************************************************************************/
/* Proprits */
/*****************************************************************************/
void prop_base_name (GtkWidget *widget, GtkObject *mod_tree);

/*****************************************************************************/
/* Menu */
/*****************************************************************************/
void menu_new_base (GtkMenuItem *menuitem, gpointer user_data);
void menu_remove_base (GtkMenuItem *menuitem, gpointer user_data);

/*****************************************************************************/
/* Barre d'outils */
/*****************************************************************************/
gboolean open_server (GtkMenuItem *menuitem, gpointer user_data);
gboolean save_server (GtkMenuItem *menuitem, gpointer user_data);

/*****************************************************************************/
/* hOpla */
/*****************************************************************************/
/* Prfix de commande hopla pour hte, port, utilisateur et mot de passe */
gchar *prefix_hopla (gchar *host, gchar *port, gchar *user, gchar *password, gchar *base, gchar *template);
gboolean plugins_load_database (GtkObject *connect);
gboolean plugins_save_database (GtkObject *connect);
gboolean plugins_save_structure (GtkObject *connect);
